% Descomposición QR (completa) usando matrices de Householder

% Idea: A, 1º columna, con un matriz de Houselholder H se puede hacer
% que se aplica en algo proporcional a e_1. Entonces H*A tiene ceros
% por debajo del a_11. Repetimos el argumento con el trozo de la matriz A
% (modificada) por debajo de a_22, a_33, etc. -> H_1H_2....A -> triangular
% superior (ortogonal/unitaria)*A=R -> A = QR

A = [1,1,2; 1,5,1; 1,1,1; 1,5,0]
n = size(A,1);
Q = eye(n);
R = A;
for k = 1:n-1
    x = R(k:n,k);
    v = zeros(n,1);
    v(k:n) = vh(x);
    % dim Qt =n es la de Householder completada con k-1 unos
    % porque v(1:k-1) son ceros
    Qt = eye(n) -2*v*v';
    Q = Qt*Q;
    R = Qt*R;
    % Para que sea exactamente triangular
    R(k+1:n,k) = zeros(n-k,1);
end
Q = Q';

Q
R

[Q,R]=qr(A)

